import type { HideErrorPropType, IdPropType, InputTypeOnDefault, KoliBriHorizontalIcons, LabelWithExpertSlotPropType, MsgPropType, NamePropType, OptionsPropType, ShortKeyPropType, SingleSelectAPI, SingleSelectStates, Stringified, SyncValueBySelectorPropType, TooltipAlignPropType } from '../../schema';
import type { JSX } from '../../stencil-public-runtime';
export declare class KolSingleSelect implements SingleSelectAPI {
    private readonly host?;
    private refInput?;
    private refOptions;
    private oldValue?;
    getValue(): Promise<string | undefined>;
    kolFocus(): Promise<void>;
    private readonly catchRef;
    private toggleListbox;
    private onBlur;
    private clearSelection;
    private selectOption;
    private onInput;
    private handleKeyDownDropdown;
    private setFilteredOptionsByQuery;
    private _focusedOptionIndex;
    private moveFocus;
    private focusOption;
    private focusSuggestionStartingWith;
    render(): JSX.Element;
    handleFocusOut(): void;
    handleWindowBlur(): void;
    handleKeyDown(event: KeyboardEvent): void;
    private readonly controller;
    private _isOpen;
    private _filteredOptions?;
    private _inputValue;
    private blockSuggestionMouseOver;
    _accessKey?: string;
    _placeholder?: string;
    _alert?: boolean;
    _disabled?: boolean;
    _hideError?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: Stringified<KoliBriHorizontalIcons>;
    _id?: IdPropType;
    _label: LabelWithExpertSlotPropType;
    _msg?: Stringified<MsgPropType>;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _options: OptionsPropType;
    _required?: boolean;
    _shortKey?: ShortKeyPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value?: string;
    state: SingleSelectStates;
    private inputHasFocus;
    constructor();
    private showAsAlert;
    validatePlaceholder(value?: string): void;
    validateAccessKey(value?: string): void;
    validateAlert(value?: boolean): void;
    validateDisabled(value?: boolean): void;
    validateHideError(value?: HideErrorPropType): void;
    validateHideLabel(value?: boolean): void;
    validateHint(value?: string): void;
    validateIcons(value?: Stringified<KoliBriHorizontalIcons>): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validateOptions(value?: OptionsPropType): void;
    validateRequired(value?: boolean): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTouched(value?: boolean): void;
    validateValue(value?: string): void;
    handleMouseEvent(): void;
    private updateInputValue;
    componentWillLoad(): void;
    private onChange;
}
